#include "juego.h"

using namespace STDP;

void Juego::iniciarJuego(int modo){ // modo es el tipo de partida seleccionada desde el menu principal
	bool findeljuego = 0;
	crearTableros();
	mostrarCuentaAtras();
	do{
		mostrarDatosJuego();
		mostrarPuntuacion();
		mostrarTablero();

		if(nivelActual>1 && listaObjetos[1][1]==0){
			bool checkEspada=false;
			for(int i = 0; i<=79 && checkEspada==false; i++){
				for(int j = 0; j<24 && checkEspada==false; j++){
					if(tablero[nivelActual][i][j]=='*' && rand() % 55 == 0){
						tablero[nivelActual][i][j] = '!';
						checkEspada=true;
					}
				}
			}
		}

		if(nivelActual>3 && listaObjetos[2][1]==0){
			bool checkEspada=false;
			for(int i = 0; i<=79 && checkEspada==false; i++){
				for(int j = 0; j<24 && checkEspada==false; j++){
					if(tablero[nivelActual][i][j]=='*' && rand() % 55 == 0){
						tablero[nivelActual][i][j] = '{';
						checkEspada=true;
					}
				}
			}
		}

		findeljuego=controlPersonaje();

		if(findeljuego==false){
			for(int i = 0; i<8; i++){
				muerteEnemigos[i][0]=1;
				muerteEnemigos[i][1]=0;
			}
			escaleras=false;

			if(nivelActual==10){
				findeljuego=true;
				if(numturnos>0)
					puntuacionPartida += 2000-numturnos;
			}
		}
		else if(findeljuego== true && vidas!=0){
			findeljuego=false;
			for(int i = 0; i<8; i++){
				muerteEnemigos[i][0]=1;
				muerteEnemigos[i][1]=0;
			}
		}

	}while(findeljuego==false);
}

void Juego::mostrarCuentaAtras(){
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);
	stdp.clearScreen();
	stdp.setCursor(0,0);
	stdp.writeChar(' ');
	cout << "\a";
	stdp.setColor(ANORMAL, CWHITE, CBLACK);
	stdp.setCursor(36,11);
	stdp.writeStr("Ready?");
	mostrarPuntuacion();
	stdp.refreshScr();
	sleep(1);
	stdp.clearScreen();
	stdp.setCursor(0,0);
	stdp.writeChar(' ');
	cout << "\a";
	stdp.setColor(ANORMAL, CWHITE, CBLACK);
	stdp.setCursor(33,11);
	stdp.writeStr("Really ready?");
	mostrarPuntuacion();
	stdp.refreshScr();
	sleep(1);
	stdp.clearScreen();
	mostrarDatosJuego();
	mostrarPuntuacion();
	stdp.setCursor(0,0);
	stdp.writeChar(' ');
	cout << "\a";
	stdp.setColor(ABOLD, CGREEN, CBLACK);
	stdp.setCursor(38,11);
	stdp.writeStr("GO!");
	stdp.refreshScr();
	sleep(1);

}

void Juego::mostrarDatosJuego(){



}

void Juego::mostrarPuntuacion(){
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);
	stdp.setColor(ABOLD, CBLUE, CBLACK);
	stdp.setCursor(0,0);
	stdp.writeStr(" Planta: ");
	char* nivelConvertido;
	nivelConvertido = new char[3];
	sprintf(nivelConvertido,"%d",nivelActual); //Convertimos el entero a cadena de caracteres
	stdp.setColor(ANORMAL, CWHITE, CBLACK);
	stdp.writeStr(nivelConvertido);

	stdp.setColor(ABOLD, CBLUE, CBLACK);
	stdp.setCursor(14,0);
	stdp.writeStr("Objeto: ");
	stdp.writeChar(listaObjetos[objetoActual][0]);

	stdp.setColor(ABOLD, CBLUE, CBLACK);
	stdp.setCursor(69,0);
	stdp.writeStr("         ");
	stdp.setCursor(69,0);
	stdp.writeStr("Vida: ");
	char* vidaConvertido;
	vidaConvertido = new char[3];
	sprintf(vidaConvertido,"%d",vidas); //Convertimos el entero a cadena de caracteres
	stdp.setColor(ANORMAL, CWHITE, CBLACK);
	stdp.writeStr(vidaConvertido);


	stdp.setColor(ABOLD, CBLUE, CBLACK);
	stdp.setCursor(32,0);
	stdp.writeStr("                   ");
	stdp.setCursor(32,0);
	stdp.writeStr("Puntuacion: ");
	char* puntuacionConvertida;
	puntuacionConvertida = new char[8];
	sprintf(puntuacionConvertida,"%d",puntuacionPartida);
	stdp.setColor(ANORMAL, CWHITE, CBLACK);
	stdp.writeStr(puntuacionConvertida);


}

void Juego::crearTableros(){

	for(int l = 1; l<=10; l++){
		//Inicializa el array
		for(int k=0; k< 80; k++){
			for(int j=1; j< 24; j++){
				tablero[l][k][j]=' ';
			}
		}

		//Tablero

		for(int j=1; j< 24; j++){
			tablero[l][0][j]='#';
			tablero[l][79][j]='#';
		}
		for(int i=0; i< 80; i++){
			tablero[l][i][1]='#';
			tablero[l][i][23]='#';
		}

		for(int j=5; j<20; j++){
			tablero[l][36][j]='#';
			tablero[l][42][j]='#';
			tablero[l][11][j]='#';
			tablero[l][68][j]='#';
		}

		for(int i=11; i<69; i++){
			tablero[l][i][5]='#';
			tablero[l][i][19]='#';
			tablero[l][i][10]='#';
			tablero[l][i][14]='#';
		}

		for(int i= 37; i<42; i++){
			tablero[l][i][5]=' ';
			tablero[l][i][10]=' ';
			tablero[l][i][14]=' ';
			tablero[l][i][19]=' ';
		}
		for(int j= 11; j<14; j++){
			tablero[l][11][j]=' ';
			tablero[l][36][j]=' ';
			tablero[l][42][j]=' ';
			tablero[l][68][j]=' ';

		}
		tablero[l][36][16]=' ';
		tablero[l][36][17]=' ';
		tablero[l][42][16]=' ';
		tablero[l][42][17]=' ';
		for(int i = 36; i<=42; i++){
			tablero[l][i][14] = '#';
			tablero[l][i][17] = '#';
		}
		tablero[l][36][15]=' ';
		tablero[l][42][15]=' ';



		for(int i = 1; i<= 77; i=i+2){
			tablero[l][i][2] = '*';
			tablero[l][i][3] = '*';
			tablero[l][i][4] = '*';
			tablero[l][i][11] = '*';
			tablero[l][i][12] = '*';
			tablero[l][i][13] = '*';
			tablero[l][i][20] = '*';
			tablero[l][i][21] = '*';
			tablero[l][i][22] = '*';
		}

		for(int j = 2; j<= 22; j++){
			tablero[l][1][j] = '*';
			tablero[l][3][j] = '*';
			tablero[l][5][j] = '*';
			tablero[l][7][j] = '*';
			tablero[l][9][j] = '*';
			tablero[l][77][j] = '*';
			tablero[l][75][j] = '*';
			tablero[l][73][j] = '*';
			tablero[l][71][j] = '*';
			tablero[l][69][j] = '*';

		}
		for(int i = 0; i<=79; i++){
			for(int j = 0; j<24; j++){
				if(tablero[l][i][j]=='*' && rand() % 55 == 0)
					tablero[l][i][j] = '$';
				if(tablero[l][i][j]=='*' && rand() % 150 == 0)
					tablero[l][i][j] = 'P';
				if(tablero[l][i][j]=='*' && rand() % 150 == 0)
					tablero[l][i][j] = 'Y';
			}
		}

		int posescalera;
		posescalera=rand() % 21 + 2;

		if(nivelActual!=10){
			tablero[l][3][posescalera] = '<';
		}

		posescalera=rand() % 21 + 2;

		if(l != 1){
			tablero[l][75][posescalera] = '>';
			inicioPersonaje[l][0]=75;
			inicioPersonaje[l][1]=posescalera;
		}
	}
	inicioPersonaje[1][1]=12;
	inicioPersonaje[1][0]=73;
	tablero[10][7][12] = '&';


}

void Juego::mostrarTablero(){
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);

	for(int i=0; i< 80; i++){
		for(int j=1; j< 24; j++){
			stdp.setCursor(i,j);


			if(tablero[nivelActual][i][j]=='#')
				stdp.setColor(ANORMAL, CRED, CBLACK);
			if(tablero[nivelActual][i][j]=='$')
				stdp.setColor(ANORMAL, CYELLOW, CBLACK);
			if(tablero[nivelActual][i][j]=='P')
				stdp.setColor(ANORMAL, CCYAN, CBLACK);
			if(tablero[nivelActual][i][j]=='<' || tablero[nivelActual][i][j]=='>')
				stdp.setColor(ANORMAL, CYELLOW, CBLACK);
			if(tablero[nivelActual][i][j]=='&')
				stdp.setColor(ANORMAL, CGREEN, CBLACK);
			if(tablero[nivelActual][i][j]=='!')
				stdp.setColor(ANORMAL, CWHITE, CBLACK);
			if(tablero[nivelActual][i][j]=='{')
				stdp.setColor(ANORMAL, CWHITE, CBLACK);



			if(tablero[nivelActual][i][j]=='*' || tablero[nivelActual][i][j]=='Y')
				stdp.writeChar(' ');
			else
				stdp.writeChar(tablero[nivelActual][i][j]);
		}
	}
}

bool Juego::controlPersonaje(){
	bool muerte = 0;
	int j = 0;

	int numeroPulsaciones = 0;
	int numeroMovimientos = 0;

	posicionPersonaje[0]=inicioPersonaje[nivelActual][0];
	posicionPersonaje[1]=inicioPersonaje[nivelActual][1];


	int teclapulsada=0;


	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);
	generarEnemigos();



	do{
		int h;
		int k;
		if(supercoco==true)
			h=1;
		else
			h=2;



		moverTodo=false;
		if(supercoco==true)
				k=2;
			else
				k=1;

		teclapulsada=stdp.getKey();

		stdp.setColor(ABOLD,CBLUE,CBLACK);
		stdp.setCursor(posicionPersonaje[0],posicionPersonaje[1]);
		stdp.writeChar('@');



			if(muerte==false){
				mostrarPuntuacion();
				usleep(35000);
			}

			if(teclapulsada==KESCAPE){
				stdp.setColor(ABOLD,CGREEN,CBLACK);
				stdp.setCursor(22,0);
				stdp.writeStr("*PAUSA*");
				do{
				}while(stdp.getKey()!=KESCAPE);
				stdp.setColor(ABOLD,CGREEN,CBLACK);
				stdp.setCursor(22,0);
				stdp.writeStr("       ");
			}

			if(muerte==false){
				//Control de las teclas con el comecocos
				if(botonAtacar == false && teclapulsada==KRIGHT && (tablero[nivelActual][posicionPersonaje[0]+2][posicionPersonaje[1]] != '#' && tablero[nivelActual][posicionPersonaje[0]+1][posicionPersonaje[1]] != '#' && tablero[nivelActual][posicionPersonaje[0]+2][posicionPersonaje[1]] != '#')){
					moverTodo=true;
					numturnos++;
					stdp.setCursor(posicionPersonaje[0],posicionPersonaje[1]);
					stdp.writeChar(' ');
					for(int i = 0; i<nivelActual+1 && i < 8; i++){
						if(posicionEnemigos[i][0]==posicionPersonaje[0]+2 && posicionEnemigos[i][1]==posicionPersonaje[1])
							botonAtacar=true;
					}
					if(botonAtacar==false)
						posicionPersonaje[0]+=2;
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == '$'){
						puntuacionPartida+=10;

						tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == 'P' && vidas < 100){
						vidas += 10;
						if(vidas > 100)
							vidas=100;
						tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == 'Y' || tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == '^'){
											vidas -= 10;

											tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
										}
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == '!'){
						listaObjetos[1][1]=1;

						tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == '{'){
						listaObjetos[2][1]=1;

						tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}

				}
				else if(botonAtacar == false && teclapulsada==KLEFT && (tablero[nivelActual][posicionPersonaje[0]-1][posicionPersonaje[1]]!= '#' && tablero[nivelActual][posicionPersonaje[0]-2][posicionPersonaje[1]]!= '#' && tablero[nivelActual][posicionPersonaje[0]-2][posicionPersonaje[1]] != '#')){
										moverTodo=true;
					numturnos++;
					stdp.setCursor(posicionPersonaje[0],posicionPersonaje[1]);
					stdp.writeChar(' ');
					for(int i = 0; i<nivelActual+1 && i < 8; i++){
						if(posicionEnemigos[i][0]==posicionPersonaje[0]-2 && posicionEnemigos[i][1]==posicionPersonaje[1])
							botonAtacar=true;
					}
					if(botonAtacar==false)
					posicionPersonaje[0]-=2;
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == '$'){
						puntuacionPartida+=10;

						tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == 'P' && vidas < 100){
						vidas += 10;
						if(vidas > 100)
							vidas=100;
						tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == 'Y' || tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == '^'){
											vidas -= 10;

											tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
										}
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == '!'){
						listaObjetos[1][1]=1;

						tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == '{'){
						listaObjetos[2][1]=1;

						tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}
				}
				else if(botonAtacar == false && teclapulsada==KUP && (tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]-1]!= '#' && tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]-1] != '#')){
										moverTodo=true;
					numturnos++;
					stdp.setCursor(posicionPersonaje[0],posicionPersonaje[1]);
					stdp.writeChar(' ');
					for(int i = 0; i<nivelActual+1 && i < 8; i++){
						if(posicionEnemigos[i][0]==posicionPersonaje[0] && posicionEnemigos[i][1]==posicionPersonaje[1]-1)
							botonAtacar=true;
					}
					if(botonAtacar==false)
					posicionPersonaje[1]--;
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == '$'){
						puntuacionPartida+=10;

						tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == 'P' && vidas < 100){
						vidas += 10;
						if(vidas > 100)
							vidas=100;
						tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == 'Y' || tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == '^'){
											vidas -= 10;

											tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
										}
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == '!'){
						listaObjetos[1][1]=1;

						tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == '{'){
						listaObjetos[2][1]=1;

						tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}

				}
				else if(botonAtacar == false && teclapulsada==KDOWN && (tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]+1]!= '#' && tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]+1] != '#')){
										moverTodo=true;
					numturnos++;
					stdp.setCursor(posicionPersonaje[0],posicionPersonaje[1]);
					stdp.writeChar(' ');
					for(int i = 0; i<nivelActual+1 && i < 8; i++){
						if(posicionEnemigos[i][0]==posicionPersonaje[0] && posicionEnemigos[i][1]==posicionPersonaje[1]+1)
							botonAtacar=true;
					}
					if(botonAtacar==false)
					posicionPersonaje[1]++;
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == '$'){
						puntuacionPartida+=10;

						tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == 'P' && vidas < 100){
						vidas += 10;
						if(vidas > 100)
							vidas=100;
						tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == 'Y' || tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == '^'){
											vidas -= 10;

											tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
										}
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == '!'){
						listaObjetos[1][1]=1;

						tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == '{'){
						listaObjetos[2][1]=1;

						tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}

				}
				else if(botonAtacar == false && teclapulsada==KUR && (tablero[nivelActual][posicionPersonaje[0]+2][posicionPersonaje[1]-1]!= '#' && tablero[nivelActual][posicionPersonaje[0]+2][posicionPersonaje[1]-1]!= '#' && tablero[nivelActual][posicionPersonaje[0]+1][posicionPersonaje[1]-1]!= '#' && tablero[nivelActual][posicionPersonaje[0]+2][posicionPersonaje[1]-1] && tablero[nivelActual][posicionPersonaje[0]+1][posicionPersonaje[1]-1]!= '#')){
										moverTodo=true;
					numturnos++;
					stdp.setCursor(posicionPersonaje[0],posicionPersonaje[1]);
					stdp.writeChar(' ');
					for(int i = 0; i<nivelActual+1 && i < 8; i++){
						if(posicionEnemigos[i][0]==posicionPersonaje[0]+2 && posicionEnemigos[i][1]==posicionPersonaje[1]-1)
							botonAtacar=true;
					}
					if(botonAtacar==false){
					posicionPersonaje[1]--;

					posicionPersonaje[0]+=2;
					}
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == '$'){
						puntuacionPartida+=10;

						tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == 'P' && vidas < 100){
										vidas += 10;
										if(vidas > 100)
											vidas=100;
										tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
									}
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == 'Y' || tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == '^'){
											vidas -= 10;

											tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
										}
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == '!'){
						listaObjetos[1][1]=1;

						tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == '{'){
						listaObjetos[2][1]=1;

						tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}
				}
				else if(botonAtacar == false && teclapulsada==KUL && (tablero[nivelActual][posicionPersonaje[0]-1][posicionPersonaje[1]-1]!= '#' && tablero[nivelActual][posicionPersonaje[0]-2][posicionPersonaje[1]-1]!= '#' && tablero[nivelActual][posicionPersonaje[0]-1][posicionPersonaje[1]-1] != '#')){
										moverTodo=true;
					numturnos++;
					stdp.setCursor(posicionPersonaje[0],posicionPersonaje[1]);
					stdp.writeChar(' ');
					for(int i = 0; i<nivelActual+1 && i < 8; i++){
						if(posicionEnemigos[i][0]==posicionPersonaje[0]-2 && posicionEnemigos[i][1]==posicionPersonaje[1]-1)
							botonAtacar=true;
					}
					if(botonAtacar==false){
					posicionPersonaje[1]--;
					posicionPersonaje[0]-=2;
					}
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == '$'){
						puntuacionPartida+=10;

						tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == 'P' && vidas < 100){
						vidas += 10;
						if(vidas > 100)
							vidas=100;
						tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == 'Y' || tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == '^'){
											vidas -= 10;

											tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
										}
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == '!'){
						listaObjetos[1][1]=1;

						tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == '{'){
						listaObjetos[2][1]=1;

						tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}
				}
				else if(botonAtacar == false && teclapulsada==KDR && (tablero[nivelActual][posicionPersonaje[0]+2][posicionPersonaje[1]+1]!= '#' && tablero[nivelActual][posicionPersonaje[0]+1][posicionPersonaje[1]+1]!= '#' && tablero[nivelActual][posicionPersonaje[0]+2][posicionPersonaje[1]+1] != '#')){
										moverTodo=true;
					numturnos++;
					stdp.setCursor(posicionPersonaje[0],posicionPersonaje[1]);
					stdp.writeChar(' ');
					for(int i = 0; i<nivelActual+1 && i < 8; i++){
											if(posicionEnemigos[i][0]==posicionPersonaje[0]+2 && posicionEnemigos[i][1]==posicionPersonaje[1]+1)
												botonAtacar=true;
										}
										if(botonAtacar==false){
					posicionPersonaje[1]++;
					posicionPersonaje[0]+=2;
										}
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == '$'){
						puntuacionPartida+=10;

						tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == 'P' && vidas < 100){
						vidas += 10;
						if(vidas > 100)
							vidas=100;
						tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == 'Y' || tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == '^'){
											vidas -= 10;

											tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
										}
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == '!'){
						listaObjetos[1][1]=1;

						tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == '{'){
						listaObjetos[2][1]=1;

						tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}
				}
				else if(botonAtacar == false && teclapulsada==KDL && (tablero[nivelActual][posicionPersonaje[0]-1][posicionPersonaje[1]+1]!= '#' && tablero[nivelActual][posicionPersonaje[0]-2][posicionPersonaje[1]+1]!= '#' && tablero[nivelActual][posicionPersonaje[0]-1][posicionPersonaje[1]+1] != '#')){
										moverTodo=true;
					numturnos++;
					stdp.setCursor(posicionPersonaje[0],posicionPersonaje[1]);
					stdp.writeChar(' ');
					for(int i = 0; i<nivelActual+1 && i < 8; i++){
											if(posicionEnemigos[i][0]==posicionPersonaje[0]-2 && posicionEnemigos[i][1]==posicionPersonaje[1]-1)
												botonAtacar=true;
										}
										if(botonAtacar==false){
					posicionPersonaje[1]++;
					posicionPersonaje[0]-=2;
										}
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == '$'){
						puntuacionPartida+=10;

						tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == 'P' && vidas < 100){
						vidas += 10;
						if(vidas > 100)
							vidas=100;
						tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == 'Y' || tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == '^'){
						vidas -= 10;

						tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == '!'){
						listaObjetos[1][1]=1;

						tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}
					if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] == '{'){
						listaObjetos[2][1]=1;

						tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}
				}
				else if(teclapulsada==KHELP){
					mostrarAyuda();
					moverTodo=true;
				}
				else if(teclapulsada==KINV){
					do{
						mostrarInventario();
						usleep(150000);
					}while(stdp.getKey()!=KINV);
					moverTodo=true;
				}

				else if(teclapulsada==KOBJ){
					borrarObjeto=false;
					seleccionarInventario();
					moverTodo=true;
				}

				else if(teclapulsada==KTIRAR){
					borrarObjeto=true;
					seleccionarInventario();
					moverTodo=true;
				}
				else if(botonAtacar == false && teclapulsada==KNONE){
					moverTodo=true;
					numturnos++;
					if(tablero[nivelActual][posicionPersonaje[0]+2][posicionPersonaje[1]]=='Y'){
						tablero[nivelActual][posicionPersonaje[0]+2][posicionPersonaje[1]]='^';
						mostrarTablero();
					}
					else if(tablero[nivelActual][posicionPersonaje[0]+2][posicionPersonaje[1]+1]=='Y'){
						tablero[nivelActual][posicionPersonaje[0]+2][posicionPersonaje[1]+1]='^';
						mostrarTablero();
					}
					else if(tablero[nivelActual][posicionPersonaje[0]+2][posicionPersonaje[1]-1]=='Y'){
						tablero[nivelActual][posicionPersonaje[0]+2][posicionPersonaje[1]-1]='^';
						mostrarTablero();
					}
					else if(tablero[nivelActual][posicionPersonaje[0]-2][posicionPersonaje[1]]=='Y'){
						tablero[nivelActual][posicionPersonaje[0]-2][posicionPersonaje[1]]='^';
						mostrarTablero();
					}
					else if(tablero[nivelActual][posicionPersonaje[0]-2][posicionPersonaje[1]+1]=='Y'){
						tablero[nivelActual][posicionPersonaje[0]-2][posicionPersonaje[1]+1]='^';
						mostrarTablero();
					}
					else if(tablero[nivelActual][posicionPersonaje[0]-2][posicionPersonaje[1]-1]=='Y'){
						tablero[nivelActual][posicionPersonaje[0]-2][posicionPersonaje[1]-1]='^';
						mostrarTablero();
					}
					else if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]+1]=='Y'){
						tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]+1]='^';
						mostrarTablero();
					}
					else if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]-1]=='Y'){
						tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]-1]='^';
						mostrarTablero();
					}
				}
				else if(teclapulsada== KSTEPS && tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]]=='<'){
					escaleras = true;
					nivelActual++;
				}
				else if(teclapulsada== KSTEPS && tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]]=='>'){
					escaleras = true;
					nivelActual--;
				}
				else if(teclapulsada==KATACAR)
					botonAtacar=true;

				if(botonAtacar == true){
					if(teclapulsada==KUP){
						for(int i = 0; i<nivelActual+1 && i < 8; i++){
							if(posicionEnemigos[i][0]==posicionPersonaje[0] && posicionEnemigos[i][1]==posicionPersonaje[1]-1)
								if(objetoActual==1)
									posicionEnemigos[i][2]-=2;
								else
									posicionEnemigos[i][2]--;
						}
																						botonAtacar=false;
																moverTodo=true;

					}
					if(teclapulsada==KUR){
											for(int i = 0; i<nivelActual+1 && i < 8; i++){
												if(posicionEnemigos[i][0]==posicionPersonaje[0]+2 && posicionEnemigos[i][1]==posicionPersonaje[1]-1)
													if(objetoActual==1)
																						posicionEnemigos[i][2]-=2;
																					else
																						posicionEnemigos[i][2]--;
											}
																											botonAtacar=false;
																moverTodo=true;

										}
					if(teclapulsada==KRIGHT){
											for(int i = 0; i<nivelActual+1 && i < 8; i++){
												if(posicionEnemigos[i][0]==posicionPersonaje[0]+2 && posicionEnemigos[i][1]==posicionPersonaje[1])
													if(objetoActual==1)
																						posicionEnemigos[i][2]-=2;
																					else
																						posicionEnemigos[i][2]--;
											}
											botonAtacar=false;
moverTodo=true;
										}
					if(teclapulsada==KDR){
											for(int i = 0; i<nivelActual+1 && i < 8; i++){
												if(posicionEnemigos[i][0]==posicionPersonaje[0]+2 && posicionEnemigos[i][1]==posicionPersonaje[1]+1)
													if(objetoActual==1)
																						posicionEnemigos[i][2]-=2;
																					else
																						posicionEnemigos[i][2]--;
											}
																											botonAtacar=false;
																moverTodo=true;

										}
					if(teclapulsada==KDOWN){
											for(int i = 0; i<nivelActual+1 && i < 8; i++){
												if(posicionEnemigos[i][0]==posicionPersonaje[0] && posicionEnemigos[i][1]==posicionPersonaje[1]+1)
													if(objetoActual==1)
																						posicionEnemigos[i][2]-=2;
																					else
																						posicionEnemigos[i][2]--;
											}
																											botonAtacar=false;
																moverTodo=true;

										}
					if(teclapulsada==KDL){
											for(int i = 0; i<nivelActual+1 && i < 8; i++){
												if(posicionEnemigos[i][0]==posicionPersonaje[0]-2 && posicionEnemigos[i][1]==posicionPersonaje[1]+1)
													if(objetoActual==1)
																						posicionEnemigos[i][2]-=2;
																					else
																						posicionEnemigos[i][2]--;
											}
											botonAtacar=false;
moverTodo=true;
										}
					if(teclapulsada==KLEFT){
											for(int i = 0; i<nivelActual+1 && i < 8; i++){
												if(posicionEnemigos[i][0]==posicionPersonaje[0]-2 && posicionEnemigos[i][1]==posicionPersonaje[1])
													if(objetoActual==1)
																						posicionEnemigos[i][2]-=2;
																					else
																						posicionEnemigos[i][2]--;
											}
																											botonAtacar=false;
																moverTodo=true;

										}
					if(teclapulsada==KUL){
											for(int i = 0; i<nivelActual+1 && i < 8; i++){
												if(posicionEnemigos[i][0]==posicionPersonaje[0]-2 && posicionEnemigos[i][1]==posicionPersonaje[1]-1)
													if(objetoActual==1)
																						posicionEnemigos[i][2]-=2;
																					else
																						posicionEnemigos[i][2]--;
											}
																											botonAtacar=false;
																moverTodo=true;

										}
					if(teclapulsada==KNONE){
																for(int i = 0; i<nivelActual+1 && i < 8; i++){
																	if(posicionEnemigos[i][0]==posicionPersonaje[0] && posicionEnemigos[i][1]==posicionPersonaje[1])
																		posicionEnemigos[i][2]--;
																}
																																botonAtacar=false;
																moverTodo=true;



															}
					for(int i = 0; i<nivelActual+1 && i < 8; i++){
						if(muerteEnemigos[i][0]== 0 && posicionEnemigos[i][2]==0){
							muerteEnemigos[i][0]=1;
							muerteEnemigos[i][1]=50;
							puntuacionPartida+=100;
							posicionEnemigos[i][0]=0;
							posicionEnemigos[i][0]=0;
						}
					}
				}

				if(movimientosSupercoco==0)
					supercoco=false;
				if(tablero[nivelActual][posicionPersonaje[0]][posicionPersonaje[1]]=='&'){
					escaleras=true;
					stdp.setColor(ABOLD,CRED,CBLACK);
					stdp.setCursor(21,7);
					stdp.writeStr("FIN");
					stdp.refreshScr();
					sleep(2);
				}
			}

			for(h;h>0 && muerte == false;h--){
				controlEnemigos(h,muerte);
			}
			if(vidas <= 0){
				vidas=0;
				muerte=true;
				mostrarPuntuacion();
				stdp.refreshScr();
			}


	}while(escaleras == false && muerte == false);
	if(muerte==true){

		mostrarTablero();

		for(int j = 0; j<5; j++){
			stdp.setColor(ABOLD,CWHITE,CBLACK);
			stdp.setCursor(posicionPersonaje[0],posicionPersonaje[1]);
			stdp.writeChar('@');
			stdp.refreshScr();
			usleep(100000);
			stdp.setColor(ABOLD,CBLUE,CBLACK);
			stdp.setCursor(posicionPersonaje[0],posicionPersonaje[1]);
			stdp.writeChar('@');
			stdp.refreshScr();
			usleep(100000);
			stdp.setCursor(0,0);
			stdp.writeChar(' ');
			cout << "\a";
		}

		stdp.setColor(ABOLD,CGREEN,CBLACK);
		stdp.setCursor(53,7);
		stdp.writeStr("Pulsa");
		stdp.setCursor(52,8);
		stdp.writeStr("Espacio");
		if(vidas==0){
			stdp.setColor(ABOLD,CRED,CBLACK);
			stdp.setCursor(21,7);
			stdp.writeStr("FIN");
		}
		do{
		}while(stdp.getKey()!=KSPACE);

	}
	return(muerte);
}

void Juego::controlEnemigos(int h,bool &muerte){
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);

	mostrarTablero();
	for(int i = 0; i<nivelActual+1 && i < 8; i++){
		if(muerteEnemigos[i][1]==0){
			stdp.setColor(ABOLD,CWHITE,CBLACK);
			stdp.setCursor(posicionEnemigos[i][0],posicionEnemigos[i][1]);
			if(posicionEnemigos[i][3]==0)
				stdp.writeChar('g');
			else if(posicionEnemigos[i][3]==1)
				stdp.writeChar('O');
			else if(posicionEnemigos[i][3]==2)
				stdp.writeChar('T');
		}

	}



	for(int i = 0; i<nivelActual+1 && i < 8; i++){
		if(moverTodo == true && tiempoSupercoco==0){
			if(muerteEnemigos[i][0]==1){
				muerteEnemigos[i][1]--;
			}

			else{
				if(abs(abs(posicionEnemigos[i][0] - posicionPersonaje[0])+(abs(posicionEnemigos[i][1] - posicionPersonaje[1])/2)) < radioPersecucion){
					direccionEnemigos[i][0]=posicionPersonaje[0];
					direccionEnemigos[i][1]=posicionPersonaje[1];
				}

				else{
					if(posicionEnemigos[i][0] == direccionEnemigos[i][0] && posicionEnemigos[i][1] == direccionEnemigos[i][1]){
						direccionEnemigos[i][1]= rand() % 21 + 2;
							if(rand() % 2 == 0)
								do{
								direccionEnemigos[i][0]= rand() % 5 + 3;
								}while(direccionEnemigos[i][0] % 2 == 0);
							else if(rand() % 2 == 1)
								do{
								direccionEnemigos[i][0]= rand() % 5 + 71;
								}while(direccionEnemigos[i][0] % 2 == 0);
					}
				}

				if(posicionEnemigos[i][0] == posicionPersonaje[0] && posicionEnemigos[i][1] +1 == posicionPersonaje[1])
					atacar=true;
				else if(posicionEnemigos[i][0] == posicionPersonaje[0] && posicionEnemigos[i][1]-1 == posicionPersonaje[1])
					atacar=true;
				else if(posicionEnemigos[i][0] == posicionPersonaje[0]+2 && posicionEnemigos[i][1]+1 == posicionPersonaje[1])
					atacar=true;
				else if(posicionEnemigos[i][0] == posicionPersonaje[0]+2 && posicionEnemigos[i][1]-1 == posicionPersonaje[1])
					atacar=true;
				else if(posicionEnemigos[i][0] == posicionPersonaje[0]-2 && posicionEnemigos[i][1]+1 == posicionPersonaje[1])
					atacar=true;
				else if(posicionEnemigos[i][0] == posicionPersonaje[0]-2 && posicionEnemigos[i][1]-1 == posicionPersonaje[1])
					atacar=true;
				else if(posicionEnemigos[i][0] == posicionPersonaje[0]+2 && posicionEnemigos[i][1] == posicionPersonaje[1])
					atacar=true;
				else if(posicionEnemigos[i][0] == posicionPersonaje[0]-2 && posicionEnemigos[i][1] == posicionPersonaje[1])
					atacar=true;

				if(atacar==false){
				//Objetivo a la esquina superior izquierda
				if((posicionEnemigos[i][1] - direccionEnemigos[i][1]) > 0 && (posicionEnemigos[i][0] - direccionEnemigos[i][0])>0){
					//Se mueve en diagonal
					if((tablero[nivelActual][posicionEnemigos[i][0]-1][posicionEnemigos[i][1]-1]!= '#' && tablero[nivelActual][posicionEnemigos[i][0]-2][posicionEnemigos[i][1]-1]!= '#' && tablero[nivelActual][posicionEnemigos[i][0]-1][posicionEnemigos[i][1]-1] != '#')){
						posicionEnemigos[i][1]--;
						posicionEnemigos[i][0]-=2;
					}
				//O a la Izquierda
					else if((tablero[nivelActual][posicionEnemigos[i][0]-1][posicionEnemigos[i][1]]!= '#' && tablero[nivelActual][posicionEnemigos[i][0]-2][posicionEnemigos[i][1]]!= '#' && tablero[nivelActual][posicionEnemigos[i][0]-2][posicionEnemigos[i][1]] != '#')){
						posicionEnemigos[i][0]-=2;
					}
				//O hacia arriba
					else if((tablero[nivelActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]-1]!= '#' && tablero[nivelActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]-1] != '#')){
						posicionEnemigos[i][1]--;
					}
				//O hacia abajo
					else if((tablero[nivelActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]+1]!= '#' && tablero[nivelActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]+1] != '#')){
						posicionEnemigos[i][1]++;
					}
				}

				//Si el objetivo está arriba a la derecha
				else if((posicionEnemigos[i][1] - direccionEnemigos[i][1]) > 0 && (posicionEnemigos[i][0] - direccionEnemigos[i][0])<0){
					//Se mueve en diagonal
					if((tablero[nivelActual][posicionEnemigos[i][0]+2][posicionEnemigos[i][1]-1]!= '#' && tablero[nivelActual][posicionEnemigos[i][0]+2][posicionEnemigos[i][1]-1]!= '#' && tablero[nivelActual][posicionEnemigos[i][0]+1][posicionEnemigos[i][1]-1]!= '#' && tablero[nivelActual][posicionEnemigos[i][0]+2][posicionEnemigos[i][1]-1] && tablero[nivelActual][posicionEnemigos[i][0]+1][posicionEnemigos[i][1]-1]!= '#')){
						posicionEnemigos[i][1]--;
						posicionEnemigos[i][0]+=2;
					}
				//O a la derecha
					else if((tablero[nivelActual][posicionEnemigos[i][0]+2][posicionEnemigos[i][1]] != '#' && tablero[nivelActual][posicionEnemigos[i][0]+1][posicionEnemigos[i][1]] != '#' && tablero[nivelActual][posicionEnemigos[i][0]+2][posicionEnemigos[i][1]] != '#')){
						posicionEnemigos[i][0]+=2;
					}
				//O hacia arriba
					else if((tablero[nivelActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]-1]!= '#' && tablero[nivelActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]-1] != '#')){
						posicionEnemigos[i][1]--;
					}
				//O hacia abajo
					else if((tablero[nivelActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]+1]!= '#' && tablero[nivelActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]+1] != '#')){
						posicionEnemigos[i][1]++;
					}
				}

				//Si el objetivo está abajo a la izquierda
				else if((posicionEnemigos[i][1] - direccionEnemigos[i][1]) < 0 && (posicionEnemigos[i][0] - direccionEnemigos[i][0])>0){
					//Se mueve en diagonal
					if((tablero[nivelActual][posicionEnemigos[i][0]-1][posicionEnemigos[i][1]+1]!= '#' && tablero[nivelActual][posicionEnemigos[i][0]-2][posicionEnemigos[i][1]+1]!= '#' && tablero[nivelActual][posicionEnemigos[i][0]-1][posicionEnemigos[i][1]+1] != '#')){
						posicionEnemigos[i][1]++;
						posicionEnemigos[i][0]-=2;
					}
					//O a la Izquierda
					else if((tablero[nivelActual][posicionEnemigos[i][0]-1][posicionEnemigos[i][1]]!= '#' && tablero[nivelActual][posicionEnemigos[i][0]-2][posicionEnemigos[i][1]]!= '#' && tablero[nivelActual][posicionEnemigos[i][0]-2][posicionEnemigos[i][1]] != '#')){
						posicionEnemigos[i][0]-=2;
					}
					//O hacia abajo
					else if((tablero[nivelActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]+1]!= '#' && tablero[nivelActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]+1] != '#')){
						posicionEnemigos[i][1]++;
					}
					//O hacia arriba
					else if((tablero[nivelActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]-1]!= '#' && tablero[nivelActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]-1] != '#')){
						posicionEnemigos[i][1]--;
					}
				}

				//Si el objetivo está abajo a la derecha
				else if((posicionEnemigos[i][1] - direccionEnemigos[i][1]) < 0 && (posicionEnemigos[i][0] - direccionEnemigos[i][0])<0){
					//Se mueve en diagonal
					if((tablero[nivelActual][posicionEnemigos[i][0]+2][posicionEnemigos[i][1]+1]!= '#' && tablero[nivelActual][posicionEnemigos[i][0]+1][posicionEnemigos[i][1]+1]!= '#' && tablero[nivelActual][posicionEnemigos[i][0]+2][posicionEnemigos[i][1]+1] != '#')){
						posicionEnemigos[i][1]++;
						posicionEnemigos[i][0]+=2;
					}
					//O a la derecha
					else if((tablero[nivelActual][posicionEnemigos[i][0]+2][posicionEnemigos[i][1]] != '#' && tablero[nivelActual][posicionEnemigos[i][0]+1][posicionEnemigos[i][1]] != '#' && tablero[nivelActual][posicionEnemigos[i][0]+2][posicionEnemigos[i][1]] != '#')){
						posicionEnemigos[i][0]+=2;
					}
					//O hacia abajo
					else if((tablero[nivelActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]+1]!= '#' && tablero[nivelActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]+1] != '#')){
						posicionEnemigos[i][1]++;
					}
					//O hacia arriba
					else if((tablero[nivelActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]-1]!= '#' && tablero[nivelActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]-1] != '#')){
						posicionEnemigos[i][1]--;
					}
				}
				else if((posicionEnemigos[i][0] - direccionEnemigos[i][0]) == 0 ){

					if((tablero[nivelActual][posicionEnemigos[i][0]-1][posicionEnemigos[i][1]]!= '#' && tablero[nivelActual][posicionEnemigos[i][0]-2][posicionEnemigos[i][1]]!= '#' && tablero[nivelActual][posicionEnemigos[i][0]-2][posicionEnemigos[i][1]] != '#')){
					posicionEnemigos[i][0]-=2;

					}
					else if((tablero[nivelActual][posicionEnemigos[i][0]+2][posicionEnemigos[i][1]] != '#' && tablero[nivelActual][posicionEnemigos[i][0]+1][posicionEnemigos[i][1]] != '#' && tablero[nivelActual][posicionEnemigos[i][0]+2][posicionEnemigos[i][1]] != '#')){
						posicionEnemigos[i][0]+=2;
					}
					else if((tablero[nivelActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]-1]!= '#' && tablero[nivelActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]-1] != '#')){
						posicionEnemigos[i][1]--;
					}
					else if((tablero[nivelActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]+1]!= '#' && tablero[nivelActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]+1] != '#')){
						posicionEnemigos[i][1]++;
					}
				}

				else if((posicionEnemigos[i][1] - direccionEnemigos[i][1]) == 0 ){

					if((tablero[nivelActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]-1]!= '#' && tablero[nivelActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]-1] != '#')){
						posicionEnemigos[i][1]--;
					}
					else if((tablero[nivelActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]+1]!= '#' && tablero[nivelActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]+1] != '#')){
						posicionEnemigos[i][1]++;
					}
					else if((tablero[nivelActual][posicionEnemigos[i][0]-1][posicionEnemigos[i][1]]!= '#' && tablero[nivelActual][posicionEnemigos[i][0]-2][posicionEnemigos[i][1]]!= '#' && tablero[nivelActual][posicionEnemigos[i][0]-2][posicionEnemigos[i][1]] != '#')){
					posicionEnemigos[i][0]-=2;

					}
					else if((tablero[nivelActual][posicionEnemigos[i][0]+2][posicionEnemigos[i][1]] != '#' && tablero[nivelActual][posicionEnemigos[i][0]+1][posicionEnemigos[i][1]] != '#' && tablero[nivelActual][posicionEnemigos[i][0]+2][posicionEnemigos[i][1]] != '#')){
						posicionEnemigos[i][0]+=2;
					}
				}
				}
				else{
					if(posicionEnemigos[i][3]==0)
						if(objetoActual==2)
							vidas-=1;
						else
							vidas-=2;
					else if(posicionEnemigos[i][3]==1)
						if(objetoActual==2)
							vidas-=2;
						else
							vidas-=4;
					else if(posicionEnemigos[i][3]==2)
						if(objetoActual==2)
							vidas-=3;
						else
							vidas-=6;
					atacar=false;
				}

			}
		}
		else if(tiempoSupercoco!=0)
			tiempoSupercoco--;
		else if(supercoco==true && tiempoSupercoco==0){
			tiempoSupercoco=8;
		}
		else if(supercoco == true && posicionEnemigos[i][0] == posicionPersonaje[0] && posicionEnemigos[i][1] == posicionPersonaje[1]){
			muerteEnemigos[i][0]=1;
			muerteEnemigos[i][1]=50;
			puntuacionPartida+=10;
			posicionEnemigos[i][0]=0;
			posicionEnemigos[i][0]=0;
		}
		generarEnemigos();
	}
	stdp.refreshScr();
}

void Juego::generarEnemigos(){
	for(int i = 0; i<nivelActual+1 && i < 8; i++){
		if(muerteEnemigos[i][0]==1 && muerteEnemigos[i][1]==0){
			do{
			posicionEnemigos[i][0]=rand() % 5 + 37;
			posicionEnemigos[i][1]=rand() % 6 + 5;
			posicionEnemigos[i][2]=4;
			posicionEnemigos[i][3]=0;
			}while(posicionEnemigos[i][0] % 2==0);


			for(int j = i; j>=0;j--){
				while(posicionEnemigos[i][0] == posicionEnemigos[j][0] && posicionEnemigos[i][1] == posicionEnemigos[j][1] && i != j){
					do{
						posicionEnemigos[i][0]=rand() % 4 + 37;
						posicionEnemigos[i][1]=rand() % 5 + 5;
					}while(posicionEnemigos[i][0] % 2==0);
				}
			}
			if(nivelActual > 2){
							posicionEnemigos[3][2]=8;
							posicionEnemigos[3][3]=1;

							if(nivelActual>5){
								posicionEnemigos[4][2]=8;
								posicionEnemigos[4][3]=1;

							}
						}
			if(nivelActual == 5){
				posicionEnemigos[1][2]=14;
				posicionEnemigos[1][3]=2;

			}
			if(nivelActual == 10){
				posicionEnemigos[1][2]=14;
				posicionEnemigos[1][3]=2;
				posicionEnemigos[2][2]=14;
				posicionEnemigos[2][3]=2;
			}
			muerteEnemigos[i][0]=0;
		}

	}
}

void Juego::mostrarInventario(){
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);

	stdp.clearScreen();

	stdp.setCursor(15,4);
	stdp.writeStr("  _____                      _             _       ");
	stdp.setCursor(15,5);
	stdp.writeStr("  \\_   \\_ ____   _____ _ __ | |_ __ _ _ __(_) ___  ");
	stdp.setCursor(15,6);
	stdp.writeStr("   / /\\/ '_ \\ \\ / / _ \\ '_ \\| __/ _` | '__| |/ _ \\ ");
	stdp.setCursor(15,7);
	stdp.writeStr("/\\/ /_ | | | \\ V /  __/ | | | || (_| | |  | | (_) |");
	stdp.setCursor(15,8);
	stdp.writeStr("\\____/ |_| |_|\\_/ \\___|_| |_|\\__\\__,_|_|  |_|\\___/ ");

	stdp.setCursor(34,13);
	stdp.writeStr("Sin nada: ' '");
	if(listaObjetos[1][1]==1){
		stdp.setCursor(36,14);
		stdp.writeStr("Espada: !");
	}
	if(listaObjetos[2][1]==1){
		stdp.setCursor(36,15);
		stdp.writeStr("Escudo: {");
	}


}

void Juego::seleccionarInventario(){
	int posicionCursor=0;
	int tecla=0;
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);

	stdp.clearScreen();

	stdp.setCursor(15,4);
	stdp.writeStr("  _____                      _             _       ");
	stdp.setCursor(15,5);
	stdp.writeStr("  \\_   \\_ ____   _____ _ __ | |_ __ _ _ __(_) ___  ");
	stdp.setCursor(15,6);
	stdp.writeStr("   / /\\/ '_ \\ \\ / / _ \\ '_ \\| __/ _` | '__| |/ _ \\ ");
	stdp.setCursor(15,7);
	stdp.writeStr("/\\/ /_ | | | \\ V /  __/ | | | || (_| | |  | | (_) |");
	stdp.setCursor(15,8);
	stdp.writeStr("\\____/ |_| |_|\\_/ \\___|_| |_|\\__\\__,_|_|  |_|\\___/ ");

	stdp.setCursor(31,10);
	stdp.writeStr("Selecciona el objeto:");
	stdp.setCursor(27,11);
	stdp.writeStr("(espacio para seleccionar)");

	stdp.setCursor(35,13);
	stdp.writeStr("Sin nada: ' '");
	if(listaObjetos[1][1]==1){
		stdp.setCursor(37,14);
		stdp.writeStr("Espada: !");
	}
	if(listaObjetos[2][1]==1){
		stdp.setCursor(37,15);
		stdp.writeStr("Escudo: {");
	}

	do{
		tecla=stdp.getKey();
			if(posicionCursor==0){
				stdp.setCursor(49,13);
				stdp.writeStr("<---");
				stdp.setCursor(49,14);
				stdp.writeStr("    ");
				stdp.setCursor(49,15);
				stdp.writeStr("    ");
			}
			else if(posicionCursor==1){
				stdp.setCursor(49,14);
				stdp.writeStr("<---");
				stdp.setCursor(49,15);
				stdp.writeStr("    ");
				stdp.setCursor(49,13);
				stdp.writeStr("    ");
			}
			else if(posicionCursor==2){
				stdp.setCursor(49,15);
				stdp.writeStr("<---");
				stdp.setCursor(49,14);
				stdp.writeStr("    ");
				stdp.setCursor(49,13);
				stdp.writeStr("    ");
			}

			if(tecla==KDOWN && posicionCursor < 2 && listaObjetos[1][1]==1 && listaObjetos[2][1]==1)
				posicionCursor+=1;
			else if(tecla==KDOWN && posicionCursor < 2 && listaObjetos[2][1]==1)
				posicionCursor+=2;
			else if(tecla==KDOWN && posicionCursor < 1 && listaObjetos[1][1]==1)
				posicionCursor+=1;

			if(tecla==KUP && posicionCursor > 0 && listaObjetos[1][1]==1)
				posicionCursor-=1;
			else if(tecla==KUP && posicionCursor > 0 && listaObjetos[2][1]==1)
				posicionCursor-=2;
			stdp.refreshScr();
		}while(tecla!=KSPACE && tecla!=KESCAPE);
	if(tecla==KSPACE){
		if(borrarObjeto==false){
			if(posicionCursor==1 && listaObjetos[1][1]==0)
				posicionCursor=1;
			objetoActual=posicionCursor;
		}
		if(borrarObjeto==true){
			if(posicionCursor!=0){
				if(posicionCursor==1 && listaObjetos[1][1]==0)
					posicionCursor=1;
				if(objetoActual==posicionCursor)
					objetoActual=0;
				listaObjetos[posicionCursor][1]=0;
			}
		}
	}

}

void Juego::mostrarAyuda(){

		StdPijo& stdp = StdPijo::p();

		stdp.init();
		stdp.setGlobalEscapeDelay(0);

		stdp.clearScreen();

		stdp.setCursor(24,1);
		stdp.writeStr(" _______                 __        ");
		stdp.setCursor(24,2);
		stdp.writeStr("|   _   |.--.--.--.--.--|  |.---.-.");
		stdp.setCursor(24,3);
		stdp.writeStr("|       ||  |  |  |  |  _  ||  _  |");
		stdp.setCursor(24,4);
		stdp.writeStr("|___|___||___  |_____|_____||___._|");
		stdp.setCursor(24,5);
		stdp.writeStr("         |_____|                   ");

		stdp.setCursor(3,7);
		stdp.writeStr("    Las teclas para jugar son:");
		stdp.setCursor(3,9);
		stdp.writeStr("Q,W,E,D,C,X,Z,A -> teclas de direccion || S -> pasar de turno");
		stdp.setCursor(3,10);
		stdp.writeStr("F -> subir o bajar escaleras || I -> listar objetos de inventario");
		stdp.setCursor(3,11);
		stdp.writeStr("U -> usar objeto de inventario || J -> tirar objeto de inventario");
		stdp.setCursor(3,12);
		stdp.writeStr("R -> atacar en la direccion que se escoja justo después");
		stdp.setCursor(3,13);
		stdp.writeStr("ESC -> pausa");

		stdp.setCursor(3,15);
		stdp.writeStr("    Los objetos que apareceran en la mazmorra seran $ (dinero) que");
		stdp.setCursor(3,16);
		stdp.writeStr("da puntos, < y > (escaleras), ^ (oculto, trampa) que aparece");
		stdp.setCursor(3,17);
		stdp.writeStr("al pasar un turno cerca, ! (espada), { (escudo), P (pocion),");
		stdp.setCursor(3,18);
		stdp.writeStr("y enemigos (g,O,T).");
		int tecla;
		do{
			tecla = stdp.getKey();
		}while(tecla!=KSPACE && tecla!=KESCAPE && tecla!=KHELP);
}

int Juego::pantallaFinNivel(){

		bool posicion=0;
	int teclapulsada=0;
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);

	stdp.clearScreen();
	stdp.setColor(AUNDERLINE, CYELLOW, CBLACK);
	stdp.setCursor(33,9);
	stdp.writeStr("¡BIEN HECHO!");
	stdp.setColor(ANORMAL, CWHITE, CBLACK);
	stdp.setCursor(34,11);
	stdp.writeStr("¿Seguimos?");

	stdp.setColor(ANORMAL, CGREEN, CBLACK);
	stdp.setCursor(36,13);
	stdp.writeStr("Si");
	stdp.setColor(ANORMAL, CRED, CBLACK);
	stdp.setCursor(40,13);
	stdp.writeStr("No");

	stdp.setColor(ABOLD, CBLUE, CBLACK);
	do{
		teclapulsada=stdp.getKey();
		if(posicion==0){
			stdp.setCursor(35,13);
			stdp.writeChar('*');
			stdp.setCursor(39,13);
			stdp.writeChar(' ');
		}
		else{
			stdp.setCursor(39,13);
			stdp.writeChar('*');
			stdp.setCursor(35,13);
			stdp.writeChar(' ');
		}

		if(teclapulsada==KRIGHT)
			posicion=1;
		if(teclapulsada==KLEFT)
			posicion=0;
		stdp.refreshScr();
	}while(teclapulsada!=KSPACE);

	return(posicion);
}
